﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Regelbaseret {
    // Den semantiske del af parseren opbygger et medlems-
    // objekt, som sendes til "kode-generatoren".
    // Singleton
    public class Medlem {
        // Singleton-instans (Eager Load)
        private static Medlem instans = new Medlem();
        // Fields
        public string Navn;
        public int Fødselsår;
        public string Kategori;
        // Singleton-konstuktør - private
        private Medlem() {}
        // Properties
        // Property, der returnerer singleton-instansen
        public static Medlem Instans {get{return instans;}}   
        public override string ToString() {
            return string.Format("{0}\t{1}\t{2}", this.Navn, this.Fødselsår, this.Kategori);
        }
        public void Reset() {
            this.Navn = "";
            this.Fødselsår = 0;
            this.Kategori = "";
        }
    }
}
