using System;
using System.Collections.Generic;
using System.Text;
using Indlsning;

namespace StatePattern {
    class EfterNavnTilstand : State {
        private static EfterNavnTilstand instans = new EfterNavnTilstand();
        private EfterNavnTilstand() { }
        public static EfterNavnTilstand Instans {get{return instans;}}
        public override State ProcessEvent() {
            State state = null;
            switch (Brik.Instans.Type) {
                case (int)MedlemslisteAnalysator.Briktype.Fdselsr:
                    state = EfterFdselsrTilstand.Instans;
                    if (!state.Enter())
                        return Fejltilstand.Instans;
                    break;
                case (int)MedlemslisteAnalysator.Briktype.Navn:
                case (int)MedlemslisteAnalysator.Briktype.Junior:
                case (int)MedlemslisteAnalysator.Briktype.Senior:
                case (int)MedlemslisteAnalysator.Briktype.Semikolon:
                case (int)MedlemslisteAnalysator.Briktype.Slut:
                case (int)MedlemslisteAnalysator.Briktype.Andet:
                    state = Fejltilstand.Instans;
                    ((Fejltilstand)state).Enter(string.Format("Fejl i '{0}'. Navn forventet!", Brik.Instans.Leksem));
                    break;
            }
            return state;
        }
        public override bool Enter() {
            // Semantik: Gem navn
            Medlem.Instans.Navn = Brik.Instans.Leksem;
            return true;
        }
    }
}
