using System;
using System.Collections.Generic;
using System.Text;
using Indlsning;

namespace StatePattern {
    class EfterSemikolonTilstand : State {
        private static EfterSemikolonTilstand instans = new EfterSemikolonTilstand();
        private EfterSemikolonTilstand() { }
        public static EfterSemikolonTilstand Instans {get{return instans;}}
        public override State ProcessEvent() {
            State state = null;
            switch (Brik.Instans.Type) {    
                case (int)MedlemslisteAnalysator.Briktype.Slut:
                    state = Sluttilstand.Instans;
                    if (!state.Enter())
                        return Fejltilstand.Instans;
                    break;
                case (int)MedlemslisteAnalysator.Briktype.Navn:
                    state = EfterNavnTilstand.Instans;
                    if (!state.Enter())
                        return Fejltilstand.Instans;
                    break;
                case (int)MedlemslisteAnalysator.Briktype.Fdselsr:
                case (int)MedlemslisteAnalysator.Briktype.Junior:
                case (int)MedlemslisteAnalysator.Briktype.Senior:
                case (int)MedlemslisteAnalysator.Briktype.Semikolon:
                case (int)MedlemslisteAnalysator.Briktype.Andet:
                    state = Fejltilstand.Instans;
                    ((Fejltilstand)state).Enter(string.Format("Fejl i '{0}'. Navn eller slut forventet!", Brik.Instans.Leksem));
                    break;
            }
            return state;
        }
        public override bool Enter() {
            // Kodegenerering
            Generator.Udskriv(Medlem.Instans);
            Medlem.Instans.Reset();
            return true;
        }
    }
}
