using System;
using System.Collections.Generic;
using System.Text;
using Indlsning;

namespace StatePattern {
    public class MedlemslisteParser {
        // Fields
        private MedlemslisteAnalysator analysator;
        // Konstruktr
        public MedlemslisteParser(string input) {
            // Allokering af leksikalsk analysator
            this.analysator = new MedlemslisteAnalysator(input);
        }
        public string ParseMedlemsliste() {
            State state = State.Start();
            do {
                this.analysator.Next(); // Nste brik
                state = state.ProcessEvent(); // Nste tilstand
            } while (!(state is Fejltilstand || state is Sluttilstand));
            return state.Resultat;
        }
    }
}
