using System;
using System.Collections.Generic;
using System.Text;

namespace StatePattern {
    // Generel abstrakt State-klasse
    public abstract class State {
        // Returnerer starttilstand
        public static State Start() {return Starttilstand.Instans;}
        // Metoden returnerer nste tilstand ud fra aktuel tilstand.
        // og Brik-objektet (Singleton)
        public virtual State ProcessEvent() {return null;}
        // Udfrer semantisk check og evt. kodegenerering p en tilstand.
        // Kaldes kun af de konkrete tilstande ...
        public virtual bool Enter() {return true;}
        // Returnerer parse-resultat.
        // Kaldes kun af slut- og fejl-tilstand ...
        public virtual string Resultat { get { return null; } }
    }
}
